/*  C generic template
    Reads options, displays help and version
    This software is distribuited with no warranty
*/

#include <stdio.h>
#include <string.h>

char* getpatternname(char*);

int verbose = 0;

int main(int argc, char** argv) {
    int i;
    
    if (argc<2) { noargs(); return(0); }
    for (i=1;i<argc;i++) if (testoption(argv[i])) return(0);
    for (i=1;i<argc;i++) if (argv[i][0]!='-') if (dofile(argv[i])) return(0);
    return 0;
}

FILE* fin;
FILE* fout;
FILE* fpat;

int dofile(char* filename) {
    int c;
    
    if (verbose) printf("Opening file %s\n", filename);
        
    if ((fin = fopen(filename, "rt")) == NULL) {
        printf("File error.\n");
        return -1;
    }
    if ((fout = fopen("hpattern.tmp", "wt")) == NULL) {
        printf("File error.\n");
        return -1;
    }
    
    processfile();
    
    fclose(fin);
    fclose(fout);

    //return 0;
    
    // Ricopia hpattern.tmp sul file originale, poi cancella hpattern.tmp
    
    if ((fin = fopen("hpattern.tmp", "rt")) == NULL) {
        printf("File error.\n");
        return -1;
    }
    if ((fout = fopen(filename, "wt")) == NULL) {
        printf("File error.\n");
        return -1;
    }
    
    for (;;) {
        c=fgetc(fin);
        if (feof(fin)) break;
        fputc(c,fout);
    }
    
    fclose(fin);
    fclose(fout);    
    
    unlink("hpattern.tmp");
    
    return 0;
    
}

int processfile() {
    char s[512];
    char* p;
    int skip = 0;
    
    while(fgets(s, 255, fin) != NULL) {
        p=s;
        while (*p==' ' || *p=='\t') p++;
        if (!strnicmp(p,"<!--#endpattern",15)) skip=0;
        if (!skip) fprintf(fout, "%s", s);
        if (!strnicmp(p,"<!--#pattern",12))
            if (!insertpattern(p+12)) skip = -1;
    }
        
    return 0;
}

int insertpattern(char* hpd) {
    char* pfn;
    char s[256];
    
    if ((pfn=getpatternname(hpd)) == NULL) return -1;
    
    if ((fpat = fopen(pfn, "rt")) == NULL) {
        return -1;
    }    
    if (verbose) printf("Including %s\n", pfn);
    while(fgets(s, 255, fpat) != NULL) fputs(s,fout);
    fputs("\n",fout);
    fclose(fpat);
    
    return 0;    
}

char* getpatternname(char* s) {
    char* p; char* q;
    
    if ((p=strstr(s,"file=\"")) == NULL) return NULL;
    p+=6;
    if ((q=strchr(p,'\"')) == NULL) return NULL;
    *q = 0;
    return p;
}

int noargs() {
    puts("Missing file arguments");
    puts("Try hpattern --help' for more information.");
    return 0;
}

int testoption(char* s) {
    // Interpreta i flag della stringa passata come argomento
    // e agisce di conseguenza, ritorna -1 se il programma
    // deve uscire dopo aver interpretato una certa opzione
    char *p;
    

    if (!strcmp(s,"--help"))    { showhelp(); return(-1); }
    if (!strcmp(s,"--version")) { showversion(); return(-1); }
    if (!strcmp(s,"--verbose"))   verbose=1;
    if (s[0]=='-' && s[1]!='-') {
        for (p=s+1;*p;p++) {
            if (*p=='h')    { showhelp(); return(-1); }
            if (*p=='v')    verbose=1;
        }
    }
    return(0);
}

int showhelp() {
    // Help su stdout
    puts("hpattern, HTML pattern includer");
    puts("Usage: hpattern [OPTION] <files>");
    puts("");
    puts("  -v, --verbose   : Verbose output");    
    puts("  -h, --help      : Display this help and exit");
    puts("      --version   : Display version info and exit");
    puts("");
    return(-1);
}

int showversion() {
    // version info
    puts("hpattern, HTML pattern includer, v. 1.0");
    return(-1);
}
